/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "stdafx.h"
#include "CommDSP.h"
#include <windows.h>
#include <commctrl.h>

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE			g_hInst;			// current instance
HWND				g_hWndMenuBar;		// menu bar handle

wchar_t PrincipaleSS[200];
HANDLE hComm;
bool Connected;
bool VitessePositionFlag;

// Forward declarations of functions included in this code module:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK Config(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK PiloteReferences(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void UpdatePrincipaleSS();
void EnvoieSemiWord(HWND hDlg, __int8 code, double data);

//--------------------------------------------------------------------
/* portNm =COM1,COM2 etc which ever COM port your phone is connected */
bool OpenPort( HWND hWnd, wchar_t *portNm )  
{    
	if( portNm != NULL ) // check to if port exists
    {
/* hComm is handle that makes a buffer file pointin to your
   COM port for read and write of port data */
	hComm = CreateFile( portNm, GENERIC_READ | GENERIC_WRITE, 
                        0, 
                        0, 
                        OPEN_EXISTING,
                        NULL,
                        0);
    if (hComm == INVALID_HANDLE_VALUE)
        {
        //error occured alert user about error 
					MessageBox( hWnd, portNm, _T("Port Open Error"), MB_OK);
        return false;
        }
    else  return true; // port opened successfully alert user
    }
else
    {
      // specified port missing alert user
          return false;
    }
}
//--------------------------------------------------------------------
BOOL WriteABuffer(char * lpBuf, DWORD dwToWrite)
{
OVERLAPPED osWrite = {0};
DWORD dwWritten;
BOOL fRes;
	// Issue write.
	if (!WriteFile(hComm, lpBuf, dwToWrite, &dwWritten, NULL)) 
	{
		if (GetLastError() != ERROR_IO_PENDING) 
		{  // WriteFile failed, but it isn't delayed. Report error and abort.
				fRes = FALSE;
			}
		else
		{
			 //// Write is pending.
			 //if (!GetOverlappedResult(hComm, &osWrite, &dwWritten, TRUE))
				//			{fRes = FALSE;}
			 //else
				//			{  // Write operation completed successfully.
				//			fRes = TRUE;}
		}
	}
	else
		// WriteFile completed immediately.
		fRes = TRUE;
 return fRes;
}
//--------------------------------------------------------------------
void ReadPort()
{
DWORD dwRead;        
char  chRead[250];  
// remember to adjust 250 according to the total data read
char *count = NULL;
/* flush the old values and fill with some arbitary symbol 
   thats most unlikely to appear in your data to know
   the end point after reading */
	memset(chRead,'\x91',250);  
	Sleep( 5L);
	ReadFile(hComm, chRead, 250, &dwRead, NULL); 
/* now chRead contains data . you can manipulate
   it accoring to your needs now. */
}
//--------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_COMMDSP));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//-------------------------------------------------------------------------
void UpdatePrincipaleSS()
{

}
//-------------------------------------------------------------------------
//  FUNCTION: MyRegisterClass()
//  PURPOSE: Registers the window class.
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CommDSP));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}
//-------------------------------------------------------------------------
//   FUNCTION: InitInstance(HINSTANCE, int)
//   PURPOSE: Saves instance handle and creates main window
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// title bar text
    TCHAR szWindowClass[MAX_LOADSTRING];	// main window class name

    g_hInst = hInstance; // Store instance handle in our global variable

    // SHInitExtraControls should be called once during your application's initialization to initialize any
    // of the device specific controls such as CAPEDIT and SIPPREF.
    SHInitExtraControls();

    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_COMMDSP, szWindowClass, MAX_LOADSTRING);

    //If it is already running, then focus on the window, and exit
    hWnd = FindWindow(szWindowClass, szTitle);	
    if (hWnd) 
    {
        // set focus to foremost child window
        // The "| 0x00000001" is used to bring any owned windows to the foreground and
        // activate them.
        SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
        return 0;
    } 

    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }

    // When the main window is created using CW_USEDEFAULT the height of the menubar (if one
    // is created is not taken into account). So we resize the window after creating it
    // if a menubar is present
    if (g_hWndMenuBar)
    {
        RECT rc;
        RECT rcMenuBar;

        GetWindowRect(hWnd, &rc);
        GetWindowRect(g_hWndMenuBar, &rcMenuBar);
        rc.bottom -= (rcMenuBar.bottom - rcMenuBar.top);
		
        MoveWindow(hWnd, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, FALSE);
    }

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

		return TRUE;
}
//-------------------------------------------------------------------------
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//  PURPOSE:  Processes messages for the main window.
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
int wmId, wmEvent;
PAINTSTRUCT ps;
HDC hdc;
RECT rc = { 4, 10, 100, 100};
static SHACTIVATEINFO s_sai;
char OutSS[200];
char OutSSadd[200];
wchar_t LOutSS[200];

    switch (message) 
    {
				case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 
            // Parse the menu selections:
            switch (wmId)
            {
               case IDM_HELP_ABOUT:
	                    DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
                    break;
               case IDM_CONFIG:
//	                    DialogBox(g_hInst, (LPCTSTR)IDD_CONFIGBOX, hWnd, Config);
                    //--------------------------------------------------------------------
								 if(OpenPort(hWnd, _T("COM7:")))  // opens COM7 port sur le ppc
																									// et je recois sur com7 sur le dongle BT 520
																									// emulateur com1 redirect sur com 1 mais ne marche pas vert BT :-( comm 44
											{
											DCB dcb;
											COMMTIMEOUTS timeouts;
												dcb.DCBlength = sizeof(dcb);
												// first read existing DCB
												GetCommState(hComm, &dcb);
												// diddle the DCB here. See the Library docs on "DCB"

												dcb.fOutxCtsFlow = false; 
												// Disable CTS monitoring
												dcb.fOutxDsrFlow = false;    // Disable DSR monitoring
												dcb.fDtrControl = DTR_CONTROL_DISABLE;    // Disable DTR monitoring
												dcb.fOutX = false;        // Disable XON/XOFF for transmission
												dcb.fInX = false;        // Disable XON/XOFF for receiving
												dcb.fRtsControl = RTS_CONTROL_DISABLE;    // Disable RTS (Ready To Send)
												// send modified DCB back to the port
												SetCommState(hComm, &dcb);

												timeouts.ReadIntervalTimeout = 20; 
												timeouts.ReadTotalTimeoutMultiplier = 10;
												timeouts.ReadTotalTimeoutConstant = 100;
												timeouts.WriteTotalTimeoutMultiplier = 10;
												timeouts.WriteTotalTimeoutConstant = 100;
												Connected=true;
												if (!SetCommTimeouts(hComm, &timeouts))
													{
													// error with time outs .alert user and exit
													}
											}										
										break;
               case IDM_CONTROL_SEND:
								 DialogBox(g_hInst, (LPCTSTR)IDD_PILOTEREFERENCES, hWnd, PiloteReferences);
										//	WriteABuffer("1AB0", 4);
										//sprintf(OutSSadd,"Isha %d\n", 1);
										//strcat(OutSS,OutSSadd);
										//mbstowcs(LOutSS, OutSS,400);
										//MessageBox( hWnd, LOutSS, _T("SalatTime"), MB_OK);
										//OutputDebugString ( LOutSS);
                    break;
                case IDM_EXIT:
										if (hComm) CloseHandle( hComm);
                    SendMessage (hWnd, WM_CLOSE, 0, 0);				
										break;
                default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
            }
            break;
        case WM_CREATE:
            SHMENUBARINFO mbi;

            memset(&mbi, 0, sizeof(SHMENUBARINFO));
            mbi.cbSize     = sizeof(SHMENUBARINFO);
            mbi.hwndParent = hWnd;
            mbi.nToolBarId = IDR_MENU;
            mbi.hInstRes   = g_hInst;

            if (!SHCreateMenuBar(&mbi)) 
								{
                g_hWndMenuBar = NULL;
								}
            else
								{
                g_hWndMenuBar = mbi.hwndMB;
								}
           // Initialize the shell activate info structure
            memset(&s_sai, 0, sizeof (s_sai));
            s_sai.cbSize = sizeof (s_sai);
						// ivalide tte connection future !
						Connected=false;
						break;
        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);
 						DrawText(hdc, PrincipaleSS, -1, &rc, DT_CALCRECT | DT_LEFT | DT_TOP);
						DrawText(hdc, PrincipaleSS, -1, &rc, DT_LEFT | DT_TOP);
			
			// TODO: Add any drawing code here...
              //PAINTSTRUCT ps;
              //HPEN hpen, hpOld;

              //POINT ptTriangle[3];
              //ptTriangle[0].x = 20;
              //ptTriangle[0].y = 20;
              //ptTriangle[1].x = 20;
              //ptTriangle[1].y = 170;
              //ptTriangle[2].x = 170;
              //ptTriangle[2].y = 95;

              //hpen = CreatePen( PS_SOLID, 2, 0);
              //hpOld=(HPEN)SelectObject( hdc,hpen);

              //if(VilleSelected == 0) Rectangle(hdc, 20, 20, 170, 170);

              //if(VilleSelected == 1) Ellipse(hdc, 20, 20, 170, 170);

              //if(VilleSelected == 2) Polygon(hdc, ptTriangle, 3);

              //SelectObject(hdc,hpOld);
              //DeleteObject(hpen);
            
            EndPaint(hWnd, &ps);
            break;
        case WM_DESTROY:
            CommandBar_Destroy(g_hWndMenuBar);
            PostQuitMessage(0);
            break;

        case WM_ACTIVATE:
            // Notify shell of our activate message
            SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
            break;
        case WM_SETTINGCHANGE:
            SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
            break;

        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}
//-------------------------------------------------------------------------
// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
            {
              // Create a Done button and size it.  
              SHINITDLGINFO shidi;
              shidi.dwMask = SHIDIM_FLAGS;
              shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
              shidi.hDlg = hDlg;
              SHInitDialog(&shidi);
            }
            return (INT_PTR)TRUE;

        case WM_COMMAND:
            if (LOWORD(wParam) == IDOK)
							{
              EndDialog(hDlg, LOWORD(wParam));
              return TRUE;
							}
            break;

        case WM_CLOSE:

            EndDialog(hDlg, message);
            return TRUE;

//#ifdef _DEVICE_RESOLUTION_AWARE
//        case WM_SIZE:
//            {
//						DRA::RelayoutDialog( g_hInst, hDlg, MAKEINTRESOURCE(IDD_ABOUTBOX));
//            }
//            break;
//#endif
    }
    return (INT_PTR)FALSE;
}
//-------------------------------------------------------------------------
// Message handler for about box.
INT_PTR CALLBACK Config(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
char OutSS[120];
wchar_t LOutSS[120];

    switch (message)
    {
        case WM_INITDIALOG:
            {
              // Create a Done button and size it.  
              SHINITDLGINFO shidi;
              shidi.dwMask = SHIDIM_FLAGS;
              shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
              shidi.hDlg = hDlg;
              SHInitDialog(&shidi);
            }
            return (INT_PTR)TRUE;

        case WM_COMMAND:
						switch (LOWORD(wParam))
							{
							case IDOK :
									EndDialog(hDlg, LOWORD(wParam));
									return TRUE;
									break;
							}
            break;

        case WM_CLOSE:

            EndDialog(hDlg, message);
            return TRUE;

    }
    return (INT_PTR)FALSE;
}
//-------------------------------------------------------------------------
// Message handler for PiloteReferences dialog box.
INT_PTR CALLBACK PiloteReferences(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
BOOL NoErr;
__int8 code;
double data;
char OutSS[120];
wchar_t LOutSS[120];

	switch (message)
    {
        case WM_INITDIALOG:
            {
              // Create a Done button and size it.  
              SHINITDLGINFO shidi;
              shidi.dwMask = SHIDIM_FLAGS;
              shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
              shidi.hDlg = hDlg;
              SHInitDialog(&shidi);
							VitessePositionFlag=1;
							SendDlgItemMessage(hDlg, IDC_RBVitesse, BM_SETCHECK, VitessePositionFlag, 0);
							SendDlgItemMessage(hDlg, IDC_RDPosition, BM_SETCHECK, !VitessePositionFlag, 0);
							// slider : trackbar
							SendDlgItemMessage(hDlg, IDC_SBReference, TBM_SETRANGE, TRUE, MAKELONG(-2400, 2400));
							SendDlgItemMessage(hDlg, IDC_SBReference, TBM_SETPOS, TRUE, 0);
							SetDlgItemInt(hDlg, IDC_EDITData, 0, TRUE);
						}
            return (INT_PTR)TRUE;

				case WM_HSCROLL:
						data=SendDlgItemMessage(hDlg, IDC_SBReference, TBM_GETPOS, 0, 0)/4.0;
						SetDlgItemInt(hDlg, IDC_EDITData, data, TRUE);
						if (VitessePositionFlag)		code=ID_ModeControleVitesse;
															else			code=ID_ModeControlePosition;
						EnvoieSemiWord(hDlg, code, data);
						return TRUE;
				case WM_COMMAND:
						switch (LOWORD(wParam))
							{
//						case TB_THUMBTRACK:
//									data=SendMessage(hDlg, TBM_GETPOS, 0, 0)/4.0;
//									SetDlgItemInt(hDlg, IDC_EDITData, data, TRUE);
//									if (VitessePositionFlag)		code=ID_ModeControleVitesse;
//																		else			code=ID_ModeControlePosition;
//									EnvoieSemiWord(hDlg, code, data);
									return TRUE;
						case IDC_BUTTONReset :
									data=0;
									SendDlgItemMessage(hDlg, IDC_SBReference, TBM_SETPOS, TRUE, data);
									SetDlgItemInt(hDlg, IDC_EDITData, data, TRUE);
									if (VitessePositionFlag)		code=ID_ModeControleVitesse;
																		else			code=ID_ModeControlePosition;
									EnvoieSemiWord(hDlg, code, data);
									//sprintf(OutSS, "Button reset");
									//mbstowcs(LOutSS, OutSS, 120);
									//MessageBox( hDlg, LOutSS, _T("Send dlg"), MB_OK);
									return TRUE;
						case IDC_RBVitesse :
									VitessePositionFlag=true;
									if (VitessePositionFlag)		data=0;
																		else			data=1;
									EnvoieSemiWord(hDlg, ID_ModeControle, data);
									return TRUE;
						case IDC_RDPosition :
									VitessePositionFlag=false;
									if (VitessePositionFlag)		data=0;
																		else			data=1;
									EnvoieSemiWord(hDlg, ID_ModeControle, data);
									return TRUE;
									
						case IDC_BUTTONSend :
									data=GetDlgItemInt(hDlg, IDC_EDITData, &NoErr, TRUE);
									if (NoErr){
														SendDlgItemMessage(hDlg, IDC_SBReference, TBM_SETPOS, TRUE, data*4);
														
														if (VitessePositionFlag)		code=ID_ModeControleVitesse;
																							else			code=ID_ModeControlePosition;
														EnvoieSemiWord(hDlg, code, data);
														}
									return TRUE;
							case IDOK :
									EndDialog(hDlg, LOWORD(wParam));
									return TRUE;
							}
            break;

        case WM_CLOSE:

            EndDialog(hDlg, message);
            return TRUE;
    }
    return (INT_PTR)FALSE;
}
//---------------------------------------------------------------------------
void EnvoieSemiWord(HWND hDlg, __int8 code, double data)
{
char OutSS[120];
wchar_t LOutSS[120];
char Out[4];
int WrittenCount;
__int16 idata;        // donne sur 16 bits signs dont 14 sont significatifs et 2 de controle =0
	idata=data*4;
	Out[0]=code;
	Out[1]=idata & 0x7F;    // sur 7 bits seulement
	Out[2]=(idata>>7) & 0x7F;
	Out[4]=0;
	// pas besoin du dummy char car le PPC aura int sur 1 byte reu  ---	Out[3]=13;
	if (Connected)
						{
						WrittenCount=WriteABuffer( Out, 3);
						if (!WrittenCount) 
								MessageBox( hDlg, _T("3 bytes non ecrits !"), _T("Erreur"), MB_OK |MB_ICONSTOP);
						sprintf(OutSS, "%03d: 0x%2x : c%c",UINT8(Out[0]), UINT8(Out[0]), Out[0]);
						mbstowcs(LOutSS, OutSS, 120);
						SetDlgItemText(hDlg, IDC_LabelCode, LOutSS);
						sprintf(OutSS, "%03d: 0x%2x : c%c",UINT8(Out[1]), UINT8(Out[1]), Out[1]);
						mbstowcs(LOutSS, OutSS, 120);
						SetDlgItemText(hDlg, IDC_LabelLow, LOutSS);
						sprintf(OutSS, "%03d: 0x%2x : c%c",UINT8(Out[2]), UINT8(Out[2]), Out[2]);
						mbstowcs(LOutSS, OutSS, 120);
						SetDlgItemText(hDlg, IDC_LabelHi, LOutSS);
						}
		else   {
						MessageBox( hDlg, _T("Port Com non ouvert"), _T("Erreur"), MB_OK |MB_ICONSTOP);
						sprintf(OutSS, "none");
						mbstowcs(LOutSS, OutSS, 120);
						SetDlgItemText(hDlg, IDC_LabelCode, LOutSS);
						sprintf(OutSS, "%03d: 0x%x : c%c",UINT8(Out[1]), UINT8(Out[1]), Out[2]);
						SetDlgItemText(hDlg, IDC_LabelLow, LOutSS);
						SetDlgItemText(hDlg, IDC_LabelHi, LOutSS);
						}
}